//source : http://openclassrooms.com/courses/la-programmation-systeme-en-c-sous-unix/les-tubes

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/wait.h>

#define TAILLE_MESSAGE 256	/* Correspond a la taille de la chaine a lire et a ecrire */

int main(void){
  pid_t	pid_fils;
  int descripteurTube[2];
  char messageLire[TAILLE_MESSAGE], messageEcrire[TAILLE_MESSAGE];
  printf("Creation du tube.\n");
  if (pipe(descripteurTube) != 0) {
    fprintf(stderr, "Erreur de creation du tube.\n");
    return EXIT_FAILURE;
  }
  printf("entree : %d\nsortie : %d\n",descripteurTube[1],descripteurTube[0]);
  pid_fils = fork();
  if (pid_fils == -1) {
    fprintf(stderr, "Erreur de creation du processus.\n");
    return 1;
  }
  if (pid_fils == 0) {
    printf("Fermeture de l'entree dans le fils.\n\n");
    close(descripteurTube[1]);
    sleep(1);
    read(descripteurTube[0], messageLire, TAILLE_MESSAGE);
    printf("Nous sommes dans le fils (pid = %d).\nIl a reçu le message suivant du pere : \"%s\".\n\n\n", getpid(), messageLire);
  }
  else {
    printf("\nFermeture de la sortie dans le pere.\n");
    close(descripteurTube[0]);
    sprintf(messageEcrire, "Bonjour, fils. Je suis ton pere !");
    printf("Nous sommes dans le pere (pid = %d).\nIl envoie le message suivant au fils : \"%s\".\n\n\n", getpid(), messageEcrire);
    write(descripteurTube[1], messageEcrire, TAILLE_MESSAGE);
    wait(NULL);
  }
  return 0;
}

